#include <unistd.h>

#include "system.h"
#include "field.h"
#include "keys.h"
#include "io.h"

systeemi::systeemi() : sele(8)
{
	static const unsigned char bases[18] = {2,3,4,5,6,7,8,9,10,12,14,16,18,20,24,32,36,62};
   	for(unsigned y=0; y<sizeof bases; ++y)
   		inputs[y] = new inputfield(2, 2 + y, 31, bases[y]);
   		
   	inputs[(sizeof bases)] = new inputfield(2, 22, 31, 10);
}

void systeemi::idlet()
{
	unsigned tick=0;
	for(;;)
	{
		for(unsigned y=0; y<19; ++y)
		{
			inputfield *tmp = (inputfield *)inputs[y];
			
			tmp->selected = y==sele;
			tmp->draw(tick);
		}				
		if(kbhit())break;
		UpdateVideo(1);
		usleep(20000);
		if(++tick==40)
		{
			tick=20;
		}
	}
}

void systeemi::laske(bool kaikki)
{
	inputfield *tmp2 = (inputfield *)inputs[sele];
	if(tmp2->error && tmp2->content.size())return;
	
	for(unsigned y=0; y<19; ++y)
		if(y != sele)
		{
			inputfield *tmp = (inputfield *)inputs[y];
			
			if(!tmp2->content.size())
				tmp->content = "";
			else
				tmp->laske(tmp2->content, tmp2->base, kaikki);
			tmp->key(kbhome);
		}
	if(kaikki)
	{
		tmp2->laske(tmp2->content, tmp2->base, true);
		tmp2->key(kbhome);
	}
}

void systeemi::key(int c)
{
	if(c == kbup)
	{
		if(sele > 0)sele--;
	}
	else if(c == kbdn)
	{
		if(sele < 17)sele++;
	}
	else if(c == kbenter)
		laske(true);
	else if(c == '')
		RefreshScreen();
	else
	{
		inputfield *tmp = (inputfield *)inputs[sele];
		tmp->key(c);
		if(c >= ' ' || c == kbback || c == kbdel
		|| c == kbdeline || c == kbdeleol)
		{
			tmp->error = false;
			laske(false);
			
			inputfield *tmp2 = (inputfield *)inputs[18];
			tmp2->laske(tmp->content, tmp2->base = tmp->base, true);
		}
	}
}

void systeemi::run()
{
	for(;;)
	{
		idlet();
		
		int c = getkey();
		if(c == kbesc)break;
		
		key(c);
	}	
}
